---
title: UIEvent
slug: Web/API/UIEvent
tags:
  - API
  - DOM
  - Event
  - Interface
  - Reference
  - UIEvent
  - events
---
<div>{{APIRef("DOM Events")}}</div>

<p>The <strong><code>UIEvent</code></strong> interface represents simple user interface events.</p>

<p><code>UIEvent</code> derives from {{domxref("Event")}}. Although the {{domxref("UIEvent.initUIEvent()")}} method is kept for backward compatibility, you should create a <code>UIEvent</code> object using the {{domxref("UIEvent.UIEvent", "UIEvent()")}} constructor.</p>

<p>Several interfaces are direct or indirect descendants of this one: {{domxref("MouseEvent")}}, {{domxref("TouchEvent")}}, {{domxref("FocusEvent")}}, {{domxref("KeyboardEvent")}}, {{domxref("WheelEvent")}}, {{domxref("InputEvent")}}, and {{domxref("CompositionEvent")}}.</p>

<p>{{InheritanceDiagram}}</p>

<h2 id="Constructors">Constructors</h2>

<dl>
 <dt>{{domxref("UIEvent.UIEvent()", "UIEvent()")}}</dt>
 <dd>Creates a <code>UIEvent</code> object.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<p><em>This interface also inherits properties of its parent, {{domxref("Event")}}.</em></p>

<dl>
 <dt>{{domxref("UIEvent.cancelBubble")}} {{Non-standard_inline}} {{Deprecated_inline}}</dt>
 <dd>Is a {{jsxref("Boolean")}} indicating whether the bubbling of the event has been canceled or not.</dd>
</dl>

<dl>
 <dt>{{domxref("UIEvent.detail")}}{{readonlyinline}}</dt>
 <dd>Returns a <code>long</code> with details about the event, depending on the event type.</dd>
 <dt>{{domxref("UIEvent.isChar")}} {{obsolete_inline}} {{readonlyinline}}</dt>
 <dd>Returns a {{jsxref("Boolean")}} indicating whether the event produced a key character or not.</dd>
 <dt>{{domxref("UIEvent.layerX")}} {{Non-standard_inline}} {{readonlyinline}}</dt>
 <dd>Returns the horizontal coordinate of the event relative to the current layer.</dd>
 <dt>{{domxref("UIEvent.layerY")}} {{Non-standard_inline}} {{readonlyinline}}</dt>
 <dd>Returns the vertical coordinate of the event relative to the current layer.</dd>
 <dt>{{domxref("UIEvent.pageX")}} {{Non-standard_inline}} {{readonlyinline}}</dt>
 <dd>Returns the horizontal coordinate of the event relative to the whole document.</dd>
 <dt>{{domxref("UIEvent.pageY")}} {{Non-standard_inline}} {{readonlyinline}}</dt>
 <dd>Returns the vertical coordinate of the event relative to the whole document.</dd>
 <dt>{{domxref("UIEvent.sourceCapabilities")}} {{experimental_inline}} {{readonlyinline}}</dt>
 <dd>Returns an instance of the <code>InputDeviceCapabilities</code> interface, which provides information about the physical device responsible for generating a touch event.</dd>
 <dt>{{domxref("UIEvent.view")}}{{readonlyinline}}</dt>
 <dd>Returns a {{domxref("WindowProxy")}} that contains the view that generated the event.</dd>
 <dt>{{domxref("UIEvent.which")}} {{Non-standard_inline}} {{readonlyinline}}</dt>
 <dd>Returns the numeric <code>keyCode</code> of the key pressed, or the character code (<code>charCode</code>) for an alphanumeric key pressed.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<p><em>This interface also inherits methods of its parent, {{domxref("Event")}}.</em></p>

<dl>
 <dt>{{domxref("UIEvent.initUIEvent()")}} {{deprecated_inline}}</dt>
 <dd>Initializes a <code>UIEvent</code> object. If the event has already being dispatched, this method does nothing.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('InputDeviceCapabilities')}}</td>
   <td>{{Spec2('InputDeviceCapabilities')}}</td>
   <td>Added <code>sourceCapabilities</code> property.</td>
  </tr>
  <tr>
   <td>{{SpecName('UI Events')}}</td>
   <td>{{Spec2('UI Events')}}</td>
   <td>Extend DOM3</td>
  </tr>
  <tr>
   <td>{{SpecName('DOM3 Events', '#interface-UIEvent', 'UIEvent')}}</td>
   <td>{{Spec2('DOM3 Events')}}</td>
   <td>Added the <code>UIEvent()</code> constructor, deprecated the <code>initUIEvent()</code> method and changed the type of <code>view</code> from <code>AbstractView</code> to <code>WindowProxy</code>.</td>
  </tr>
  <tr>
   <td>{{SpecName('DOM2 Events', '#Events-UIEvent', 'UIEvent')}}</td>
   <td>{{Spec2('DOM2 Events')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.UIEvent")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Learn/JavaScript/Building_blocks/Events">Introduction to events</a></li>
 <li>{{domxref("Event")}}</li>
</ul>
